#include "cConvert.h"

cConvert::cConvert(QWidget *parent) :    QWidget(parent){
    procFFmpeg  = new QProcess();

    // отключить цвет
    QProcessEnvironment env = QProcessEnvironment::systemEnvironment();
    env.insert("FFMPEG_FORCE_NOCOLOR", "1");
    procFFmpeg->setProcessEnvironment(env);


    connect(procFFmpeg,SIGNAL(readyRead()),this,SLOT(ffmpeg_readyRead()));
    connect(procFFmpeg,SIGNAL(readyReadStandardError()),this,SLOT(ffmpeg_readyRead()));
    connect(procFFmpeg,SIGNAL(readyReadStandardOutput()),this,SLOT(ffmpeg_readyRead()));
    connect(procFFmpeg,SIGNAL(finished(int)),this,SLOT(ffmpeg_finish(int)));
}


void cConvert::start(QString pathFFmpeg,QStringList arg){
    dataOutput="";
    procFFmpeg->start(pathFFmpeg,arg);
}


void cConvert::ffmpeg_readyRead(){
    QString data="";

    data.append(dataOutput);
    data.append(procFFmpeg->readAllStandardError());
    data.append(procFFmpeg->readAllStandardOutput());

    QStringList list = data.split(QRegExp("\n|\r")) ;

    dataOutput=list[list.size()-1];

    //"size=     100kB time=12.77 bitrate=  64.0kbits/s"
    // frame=  972 fps=418 q=31.0 Lsize=    1650kB time=40.58 bitrate= 333.2kbits/s dup=0 drop=1
    //video:1256kB audio:321kB global headers:0kB muxing overhead 4.638438%
    //
    // Number of stream maps must match number of output streams
    //
    // Error while opening encoder for output stream #0.0 - maybe incorrect parameters such as bit_rate, rate, width or height
    //
    for (int i = 0; i < list.size()-1; i++){
        list[i]=trim(list[i]);

        emit readyData(list[i]);

        // Нормальный ход конвертирования
        if (list[i].mid(0,5) == "frame" or list[i].mid(0,4) == "size"){
            emit changeStatusConvert(parsStatus(list[i]));
        }

        // Ошибки (Не верно подобраны параметры)
        //Кодек не поддерживается "Unsupported codec for output stream #0.0"
        if (list[i].mid(0,27) == "Error while opening encoder"
            or list[i] == "Number of stream maps must match number of output streams"
            or list[i].mid(0,33) == "Could not write header for output"
            or list[i].mid(0,17) == "Unsupported codec"
            or list[i].mid(0,21) == "Video encoding failed"
            or list[i].mid(0,14) == "Invalid value "
            or list[i] == "Output file #0 does not contain any stream"
            or regex("*Invalid data found when processing input*",list[i])==true
            or regex("Encoder * not found for output stream*",list[i])==true

            ){

            emit error(list[i]);;
        }
        // Конец конвертирования
        if (list[i].mid(0,5) == "video"){
            emit finish(1);
        }


    }
}

void cConvert::stop(){
    procFFmpeg->close();
}

void cConvert::ffmpeg_finish(int value){
}

sStatusConvert cConvert::parsStatus(QString line){
    sStatusConvert status ;

    //"size=     100kB time=12.77 bitrate=  64.0kbits/s"
    //"frame=  424 fps=422 q=30.3 size=     839kB time=17.73 bitrate= 387.6kbits/s"
    //"frame | 212 fps |   0 q | 31.0 size|     510kB time|8.88 bitrate| 470.3kbits/s"

    QStringList p=trim(line).split("=");


    if (trim(p[0])=="frame"){
        status.frame=trim(p[1]).split(" ").at(0) ;
        status.fps=trim(p[2]).split(" ").at(0) ;
        status.size =trim(p[4]).split(" ").at(0) ;
        status.time=trim(p[5]).split(" ").at(0) ;
        status.bitrate=trim(p[6]).split(" ").at(0) ;
    }
    if (trim(p[0])=="size"){
        status.frame="0";
        status.fps="0";
        status.size =trim(p[1]).split(" ").at(0);
        status.time=trim(p[2]).split(" ").at(0);
        status.bitrate=trim(p[3]).split(" ").at(0) ;
    }

    return status;
}
